--[[
	Basic RuneWatch LibDataBroker-1.1 Implementation
	Author: voorije
	Last Edited: 2009-01-15T11:28:32Z
]]

local L = LibStub("AceLocale-3.0"):GetLocale("RuneWatch");

assert(RuneWatch, "Unable to locate RuneWatch Addon Object.");

-- LibDataBroker-1.1
local ldb = LibStub:GetLibrary("LibDataBroker-1.1");
local Broker = ldb:NewDataObject("RuneWatch Broker", {
	type = "data source",
	icon = "Interface\\AddOns\\RuneWatch\\Artwork\\Icon",
	text = "RuneWatch",
	rp = 0,
	rpm = 100,
	rpp = 0,
	rp_col = { r = 1, g = 1, b = 1, a = 1 },
	tipShown = false
});

local Icon = LibStub("LibDBIcon-1.0");

RuneWatch.Broker = Broker;
RuneWatch.MMIcon = Icon;

function Broker:OnClick(button)
	if button == "RightButton" then
		RuneWatch:ShowConfig();
	end
	
	if button == "LeftButton" then
		if (RuneWatch.db.general.locked) then
			v = false;
		else
			v = true;
		end
	
		RuneWatch.db.general.locked = v; 
		RuneWatch:FireDragUpdate();
	end
end

function Broker:OnEnter()
	
	if (not Broker.tipShown) then
		GameTooltip:SetOwner(self, "ANCHOR_NONE");
		GameTooltip:SetPoint("TOPLEFT", self, "BOTTOMLEFT");
	end
	
	Broker.tipShown = true;
	
	Broker:GenerateTooltip();
	Broker:GenerateText();
end

function Broker:GenerateTooltip()
	GameTooltip:ClearLines();
	GameTooltip:AddLine("RuneWatch "..RuneWatch.Version, 1, 0.82, 0);
	GameTooltip:AddDoubleLine(L["Left-Click"], L["Lock/Unlock Frame"], 0.8, 0.6, 0.6, 0.8, 0.6, 0.6);
	GameTooltip:AddDoubleLine(L["Right-Click"], L["Open Configuration"], 0.8, 0.6, 0.6, 0.8, 0.6, 0.6);
	
	GameTooltip:Show();
end

function Broker:RuneWatch_Init(event, ...)
	if (not RuneWatch:IsDeathKnight()) then
		return;
	end

	Icon:Register("RuneWatch", Broker, RuneWatch.db.minimap);
end

function Broker:UpdateIcon()
	if (RuneWatch.db.general.minimapEnabled) then
		Icon:Show("RuneWatch");
	else
		Icon:Hide("RuneWatch");
	end
end

function Broker:GenerateText()
	
end

function Broker:OnLeave()
	Broker.tipShown = false;
	GameTooltip:Hide();
end

RuneWatch.RegisterMessage(Broker, "RuneWatch_Init");
