--[[
  Title: RuneWatch v2.0.0 Beta 5: Events
  Author: voorije
  Revised: 2009-01-15T13:13:54Z
--]]

assert(RuneWatch, "Unable to find RuneWatch Object.");
local L = LibStub("AceLocale-3.0"):GetLocale("RuneWatch");

function RuneWatch:InitEvents()
	-- Runes
	self:RegisterEvent("RUNE_POWER_UPDATE")
	self:RegisterEvent("RUNE_TYPE_UPDATE")
	
	self:RegisterMessage("RuneWatch_Gui_Update");
	self:RegisterMessage("RuneWatch_Gui_Drag");
	
	-- Timer Events
	self.UnitTimer = self:ScheduleRepeatingTimer("PollUnitData", 0.1);
end

-- Fired when a rune's usable state changes
function RuneWatch:RUNE_POWER_UPDATE(self, ...)
	local rune, usable = ...;
	
	RuneWatch:SendMessage("RuneWatch_Rune_State", rune, usable);
end

-- Fired when a rune changes type
function RuneWatch:RUNE_TYPE_UPDATE(self, ...)
	local rune = ...;
	local typ = GetRuneType(rune);
	
	RuneWatch:SendMessage("RuneWatch_Rune_Type", rune, typ);
end

function RuneWatch:FireDragUpdate()
	local locked = RuneWatch.db.general.locked;
	
	RuneWatch:SendMessage("RuneWatch_Gui_UpdateDrag"); -- Tell widgets to update thier drag frame dimensions
	RuneWatch:SendMessage("RuneWatch_Gui_Drag", locked); -- Fire the drag frame display/hide
end

-- Why do we catch our own event? this is to allow for widgets / other elements to catch the event too
function RuneWatch:RuneWatch_Gui_Drag(self, ...)
	local locked = ...;
	
	for k,drag in pairs(RuneWatch.Dragables) do
		if (locked == true) then
			drag.dragFrame:Hide();
			--[===[@alpha@
			RuneWatch:Print("Locked == 'true'");
			--@end-alpha@]===]
		else
			drag.dragFrame:Show();
			--[===[@alpha@
			RuneWatch:Print("Locked == 'false'");
			--@end-alpha@]===]
		end
	end
end

function RuneWatch:RuneWatch_Gui_Update()
	RuneWatch:FireDragUpdate();
end

function RuneWatch:PollUnitData(...)

	-- Runic Power
	local rp, rpmax = UnitMana("player"), UnitManaMax("player");
	self:SendMessage("RuneWatch_UnitData_RunicPower", rp, rpmax);
	
	-- Todo: Health
end
