--[[
  Title: RuneWatch v2.0.0 Beta 5
  Author: voorije
  Revised: 2009-01-15T13:13:54Z
--]]

-- Initialize Base Config

local options = {
	type = "group",
	args = {}
}

LibStub("AceConfigRegistry-3.0"):RegisterOptionsTable("RuneWatch", options);
local L = LibStub("AceLocale-3.0"):GetLocale("RuneWatch");

local options_pofile = {}

local cmdOptions = {
	type = "group",
	args = {}
}

--local L = LibStub("AceLocale-3.0"):GetLocale("RuneWatch");

RuneWatch.configOptions = options
LibStub("AceConfig-3.0"):RegisterOptionsTable("RuneWatchCmd", cmdOptions, {"runewatch", "rune"});

function RuneWatch:ShowConfig()
	InterfaceOptionsFrame_OpenToCategory(self.optionsFrame.General);
end

function RuneWatch:InitOptions()
	self.optionsFrame = {}
	
	local cmd = cmdOptions;
	cmd.args = {
		config = {
			type = "execute",
			name = L["Open Configuration"],
			desc = L["Open Configuration"],
			func = function() RuneWatch:ShowConfig(); end
		},
		locked = {
			type = "toggle",
			name = L["Frames Locked"],
			desc = L["Locks/Unlocks the various UI Frames"],
			get = function(info) return RuneWatch.db.general.locked end,
			set = function(info, v) RuneWatch.db.general.locked = v; RuneWatch:FireDragUpdate(); end,
		},
		version = {
			type = "execute",
			name = L["Display RuneWatch Version"],
			desc = L["Display RuneWatch Version"],
			func = function()
				RuneWatch:Print("Version [v2.0.0 Beta 5 Build 144]");
				RuneWatch:Print("Released On [2009-01-13T06:12:01Z]");
			end
		}
	}
	
	
	local genOptions = {
		type = "group",
		name = L["General"],
		desc = L["General"],
		args = {
			dsc = {
				type = "header",
				name = L["Global Options"],
				order = 5,
			},
			locked = {
				type = "toggle",
				name = L["Frames Locked"],
				desc = L["Locks/Unlocks the various UI Frames"],
				width = "full",
				get = function(info) return RuneWatch.db.general.locked end,
				set = function(info, v) RuneWatch.db.general.locked = v; RuneWatch:FireDragUpdate(); end,
				order = 10,
			},
			hideRuneframe = {
				type = "toggle",
				name = L["Hide Blizzard Runeframe"],
				desc = L["Hides/Shows the Blizzard Runeframe"],
				get = function(info) return RuneWatch.db.general.hideRuneframe end,
				set = function(info, v) RuneWatch.db.general.hideRuneframe = v; RuneWatch:UpdateRuneFrame(); end,
				order = 15
			},
			minimap = {
				type = "header",
				name = L["Minimap Options"],
				order = 20,
			},
			minimapEnabled = {
				type = "toggle",
				name = L["Enabled"],
				desc = L["Enables/Disables the Minimap Icon"],
				width = "full",
				get = function(info) return RuneWatch.db.general.minimapEnabled; end,
				set = function(info,v) RuneWatch.db.general.minimapEnabled = v; RuneWatch.Broker:UpdateIcon(); end,
				order = 25,
			}
		}
	}
	
	local proOptions = LibStub("AceDBOptions-3.0"):GetOptionsTable(RuneWatch.dbase);
	
	local ACD3 = LibStub("AceConfigDialog-3.0");
		
	-- About
	if LibStub:GetLibrary("LibAboutPanel", true) then
		self.optionsFrame["About"] = LibStub:GetLibrary("LibAboutPanel").new(nil, "RuneWatch");
	else
		--[===[@alpha@
		self:Print("LibAboutPanel is not loaded.");
		--@end-alpha@]===]
	end
		
	self:InitModuleOptions("General", L["General"], genOptions);
	self:InitModuleOptions("Profile", L["Profile..."], proOptions);
end

function RuneWatch:InitModuleOptions(id, name, cfg)
	local ACD3 = LibStub("AceConfigDialog-3.0");
	
	options.args[id] = cfg;
	self.optionsFrame[id] = ACD3:AddToBlizOptions("RuneWatch", name, "RuneWatch", id);
end

function RuneWatch:InitOptionsEnd()
	--self:Print("Init End Options...");
end
