--[[
  Title: RuneWatch v2.0.0 Beta 5
  Author: voorije
  Revised: 2009-01-26T14:55:27Z
--]]
local AceAddon = LibStub("AceAddon-3.0")
local AceDB = LibStub("AceDB-3.0")
local AceTimer = LibStub("AceTimer-3.0")

--local L = LibStub("AceLocale-3.0"):GetLocale("RuneWatch");

RuneWatch = AceAddon:NewAddon("RuneWatch", "AceConsole-3.0", "AceEvent-3.0", "AceHook-3.0", "AceTimer-3.0")
RuneWatch.Version = "v2.0.0 Beta 5";
RuneWatch.Callbacks = RuneWatch.Callbacks or LibStub("CallbackHandler-1.0"):New(RuneWatch);

-- Create Master Anchor
RuneWatch.Frame = CreateFrame("frame", "RuneWatchFrame", UIParent);

local L = LibStub("AceLocale-3.0"):GetLocale("RuneWatch");

-- Hack for X-Perl
_G["RuneFrame"]:Hide();

function RuneWatch:UpdateRuneFrame()
	if (self.db.general.hideRuneframe) then
		_G["RuneFrame"]:Hide();
	else
		_G["RuneFrame"]:Show();
	end
end

function RuneWatch:IsDeathKnight()
	local _, uclass = UnitClass("Player");
	if (uclass ~= "DEATHKNIGHT") then
		return false
	else
		return true
	end
end

function RuneWatch:OnInitialize()

	-- Initialize Master Anchor
	RuneWatch.Frame:Show();
	RuneWatch.Frame:SetWidth(10);
	RuneWatch.Frame:SetHeight(10);
	RuneWatch.Frame:SetPoint("CENTER", UIParent, "CENTER");

	if (not self:IsDeathKnight()) then
		return;
	end
	
	self.dbase = LibStub("AceDB-3.0"):New("RuneWatchDB");
	self.dbase:RegisterDefaults({
		profile = {
			minimap = {
			
			},
			modules = {
			
			},
			general = {
				firstRun = "",
				locked = true,
				minimapEnabled = true,
				hideRuneframe = true,
			},
			drags = {
			
			}
		}
	})
	self.db = self.dbase.profile;
	
	self:InitOptions();
	self:InitEvents();
end

function RuneWatch:OnEnable()
	if (not self:IsDeathKnight()) then
		return;
	end
	
	self:UpdateRuneFrame();

	self:InitOptionsEnd();
	self:Print(L["Loaded, type '/rune' for configuration options."]);
	
	self:SendMessage("RuneWatch_Init");
	
	--@beta@
	if (self.db.general.firstRun ~= "v2.0.0 Beta 5") then
		self.db.general.firstRun = "v2.0.0 Beta 5";
		
		self:Print("This appears to be your first run of this version. To get you started, type '/rune locked' to unlock the ui-components.");
		
		self:ShowBetaDisclaimer();
	end
	--@end-beta@
end

function RuneWatch:ShowBetaDisclaimer()
	local AceGUI = LibStub("AceGUI-3.0");
	
	local f = AceGUI:Create("Frame");
	f:SetTitle("Disclaimer!");
	f:SetLayout("List");
	f:SetWidth(340);
	f:SetHeight(400);
	f:Show();
	
	local l = AceGUI:Create("Label");
	l:SetText("Welcome to RuneWatch v2.x.x Beta! If you are seeing this you've just loaded up the beta version of this mod for the first time. This dialog is here to remind you that you are USING THE BETA VERSION OF THE MOD!");
	
	local l2 = AceGUI:Create("Label");
	l2:SetText("This beta is intended to give you a preview of what's new and allow me to get usefull feedback as I work on the new version. If you find a bug (and you probably will) please report it on my curseforge.com ticket tracker. Also, please remember this version probably has less features than you're used to because im in the process of re-programming them all.");
	
	local g = AceGUI:Create("InlineGroup");
	g:SetTitle("Disclaimer:");
	--g:SetLayout("Fill");
	g:AddChild(l);
	
	local g2 = AceGUI:Create("InlineGroup");
	g2:SetTitle("v2.x.x Beta Disclaimer:");
	--g2:SetLayout("Fill");
	g2:AddChild(l2);
	
	f:AddChild(g);
	f:AddChild(g2);
end

function RuneWatch:OnDisable()

end

function RuneWatch:OnUpdate(self, elapsed)
	
end

RuneWatch.Core = {}

function RuneWatch.Core:ScrollEvent(message, r, g, b)
	CombatText_AddMessage(message, COMBAT_TEXT_SCROLL_FUNCTION, r, g, b, "", false);
end

function RuneWatch.Core:PopEvent(message, r, g, b)
	CombatText_AddMessage(message, COMBAT_TEXT_SCROLL_FUNCTION, r, g, b, "crit", false);
end

function RuneWatch.Core:FlashWarning(r,g,b)

end
